angular.module('sm').directive('professorLookup', function ($http) {
  return {
    restrict: 'A',
    scope: {
      professorLookup: '='
    },
    template: '{{professorLookup}}',
    link: {
      pre: function (scope, elm, attrs) {

      },
      post: function (scope, elm, attrs) {
        if (scope.professorLookup !== '' && scope.professorLookup !== 'TBA') {
          scope.stats = 'none'
          elm.on('click', function () {
            const nameParts = scope.professorLookup.split(' ')
            const lastName = nameParts[nameParts.length - 1]
            if (scope.stats === 'none') {
              $http({
                method: 'GET',
                url: '/rmp/' + lastName,
                headers: {
                  Accept: 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8'
                }
              }).success(function (data, status, headers, config) {
                const parser = new DOMParser()
                const doc = parser.parseFromString(data, 'text/html')
                const entry = doc.querySelectorAll('#ratingTable .entry')[0]
                const getStat = function (selector) {
                  return entry.querySelectorAll(selector)[0].innerHTML
                }
                const getUrl = function () {
                  return 'http://www.ratemyprofessors.com/ShowRatings.jsp?tid=' + (entry.querySelectorAll('.profName a')[0] as HTMLLinkElement).href.split('?tid=')[1]
                }
                const ratingColor = function (score) {
                  score = parseFloat(score)
                  if (score >= 4) {
                    return '#18BC9C'
                  } else if (score >= 3) {
                    return '#F39C12'
                  } else {
                    return '#E74C3C'
                  }
                }
                scope.stats = {
                  name: getStat('.profName a'),
                  url: getUrl(),
                  dept: getStat('.profDept'),
                  numRatings: getStat('.profRatings'),
                  rating: getStat('.profAvg'),
                  easiness: getStat('.profEasy')
                }
                elm.popover({
                  html: true,
                  trigger: 'manual',
                  placement: 'auto left',
                  title: '<a target="_blank" href="' + scope.stats.url + '">' + scope.stats.name + ' - ' + scope.stats.dept + '</a>',
                  content: '<div class="row"><div class="col-xs-6 rmp-rating"><h2 style="background-color:' + ratingColor(scope.stats.rating) + '">' + scope.stats.rating + '</h2>Average Rating</div><div class="col-xs-6 rmp-rating"><h2 style="background-color:' + ratingColor(scope.stats.easiness) + '">' + scope.stats.easiness + '</h2>Easiness</div></div><div style="text-align:center">Based on ' + scope.stats.numRatings + ' ratings<br><a target="_blank" href="http://www.ratemyprofessors.com/SelectTeacher.jsp?searchName=' + lastName + '&search_submit1=Search&sid=807">Not the right professor?</a><br><small>&copy; 2013 <a target="_blank" href="http://www.ratemyprofessors.com">RateMyProfessors.com</a></small></div>'
                })
                elm.popover('show')
              })
            } else {
              elm.popover('toggle')
            }
          })
        }
      }
    }
  }
})
